//Copyright (c) 2014, Jesús Martín Berlanga. All rights reserved. 
//Distributed under the BSD licence. Read "com/jme3/ai/license.txt".
package com.jme3.ai.agents.behaviors.npc.steering;

import com.jme3.ai.agents.Agent;
import com.jme3.scene.Spatial;

/**
 * Wander behavior is steering behavior where agent moves randomly on terrain.
 * 
 * @author Jesús Martín Berlanga
 * @version 1.0
 */
public abstract class AbstractWanderBehavior extends AbstractStrengthSteeringBehavior {
    
    /**
     * Time interval durring which target position doesn't change.
     */
    protected float timeInterval;
    
    /**
     * @see
     * AbstractStrengthSteeringBehavior#AbstractSteeringBehavior(com.jme3.ai.agents.Agent)
     */
    public AbstractWanderBehavior(Agent agent) {
        super(agent);
    }

    /**
     * @see
     * AbstractStrengthSteeringBehavior#AbstractSteeringBehavior(com.jme3.ai.agents.Agent,
     * com.jme3.scene.Spatial)
     */
    public AbstractWanderBehavior(Agent agent, Spatial spatial) {
        super(agent, spatial);
    }
       
    /**
     * Get time interval for changing target position.
     *
     * @return
     */
    public float getTimeInterval() {
        return timeInterval;
    }

    /**
     * Setting time interval for changing target position.
     *
     * @param timeInterval
     */
    public void setTimeInterval(float timeInterval) {
        this.timeInterval = timeInterval;
    }
}